// 私有方法
var DOT_RE = /\/\.\//g
var DOUBLE_DOT_RE = /\/[^/]+\/\.\.\//
var DOUBLE_SLASH_RE = /([^:/])\/\//g
/**
 * 路径整理
 * @param path
 * @returns {XML}
 */
function realpath(path) {
    // /a/b/./c/./d ==> /a/b/c/d
    path = path.replace(DOT_RE, "/")

    // a/b/c/../../d  ==>  a/b/../d  ==>  a/d
    while (path.match(DOUBLE_DOT_RE)) {
        path = path.replace(DOUBLE_DOT_RE, "/")
    }
    // a//b/c  ==>  a/b/c
    path = path.replace(DOUBLE_SLASH_RE, "$1/")

    return path
}
exports.realpath = realpath
/**
 * 调用异步函数
 * @param fuc
 * @param scope
 */
exports.queue = function(fuc, scope){
    var arg = Array.prototype.slice.call(arguments, 0);
    scope = scope || {};
    (function next(){
        // 防止已为空
        if(fuc.length>0){
            var f = fuc.shift();
            f.apply(scope, [next].concat(arg))
        }
    })();
}

